{*************************************************************}
{          Delphi Control to RTF Conversion VCL               }
{ Version:   1.0                                              }
{ Author:    K. Nishita                                       }
{ E-Mail:    info@nishita.com                                 }
{ Home Page: http://nishita.com                               }
{ Created:   3/1/2000                                         }
{ Type:      Freeware                                         }
{ Legal:     Copyright (c) 1999 by K. Nishita                 }
{*************************************************************}
{ This component convert Delphi grid, edit, listbox, memo,    }
{ and label to Rich Text Format.                              }
{*************************************************************}
{ Please see example program for more information.            }
{*************************************************************}
{                     IMPORTANT NOTE:                         }
{ This software is provided 'as-is', without any express or   }
{ implied warranty. In no event will the author be held       }
{ liable for any damages arising from the use of this         }
{ software.                                                   }
{ Permission is granted to anyone to use this software for    }
{ any purpose, including commercial applications, and to      }
{ alter it and redistribute it freely, subject to the         }
{ following restrictions:                                     }
{ 1. The origin of this software must not be misrepresented,  }
{    you must not claim that you wrote the original software. }
{    If you use this software in a product, an acknowledgment }
{    in the product documentation would be appreciated but is }
{    not required.                                            }
{ 2. Altered source versions must be plainly marked as such,  }
{    and must not be misrepresented as being the original     }
{    software.                                                }
{ 3. This notice may not be removed or altered from any       }
{    source distribution.                                     }
{ 4. You must register this software by visiting              } 
{    http://nishita.com.                                      }
{*************************************************************}

unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Grids, DBGrids, Ctltortf;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Image1: TImage;
    Edit1: TEdit;
    Label1: TLabel;
    StringGrid1: TStringGrid;
    ListBox1: TListBox;
    ControlToRTF1: TCtrlToRTF;
    ToRTF: TButton;
    procedure FormShow(Sender: TObject);
    procedure ToRTFClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
var i,j:Integer;
begin
for i:=0 to StringGrid1.ColCount-1 do
for j:=0 to StringGrid1.RowCount-1 do
StringGrid1.Cells[i,j]:='Cell('+IntToStr(i)+','+IntToStr(j)+')';
end;

procedure TForm1.ToRTFClick(Sender: TObject);
begin
{Add Fonts to Table}
ControlToRTF1.AddFontToTable(Memo1.Font);
ControlToRTF1.AddFontToTable(Label1.Font);
ControlToRTF1.AddFontToTable(Edit1.Font);
ControlToRTF1.AddFontToTable(ListBox1.Font);

{Create a RTF Header}
ControlToRTF1.CreateRTFHeader;

{Convert StringGrid to RTF}
ControlToRTF1.GridToRTF(StringGrid1);

{Convert Edit to RTF}
ControlToRTF1.EditToRTF(Edit1);

{Convert Label to RTF}
ControlToRTF1.LabelToRTF(Label1);

{Convert Image to RTF}
ControlToRTF1.ImageToRTF(Image1,taLeftjustify);

{Convert Memo to RTF}
ControlToRTF1.MemoToRTF(Memo1);

{Convert ListBox to RTF}
ControlToRTF1.ListBoxToRTF(ListBox1);

{Save RTF as a File}
ControlToRTF1.SaveToFile('hello.rtf');
end;

end.
