unit About;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, WinSystem, jpeg;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    OKButton: TButton;
    lblURL: TLabel;
    WinSystem1: TWinSystem;
    lblUserName: TLabel;
    lblComputer: TLabel;
    procedure lblURLMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lblURLMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure lblURLMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.DFM}

procedure TAboutBox.lblURLMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    With self do
     begin
        lblURL.Font.Color := clRed;
     end;
end;

procedure TAboutBox.lblURLMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    With self do
     begin
        lblURL.Font.Color := clYellow;
     end;
    WinSystem1.GoWeb(self, lblURL.Caption);
end;

procedure TAboutBox.FormShow(Sender: TObject);
var
    msg: String;
    equalPos: Integer;
begin
    WinSystem1.GetOSInfo();
    msg := 'OS: ' + WinSystem1.WindowsType +
        ' ' + WinSystem1.MajorVersion + '.' + WinSystem1.MinorVersion +
        '.' + WinSystem1.BuildNumber + ' ' + WinSystem1.OtherInfo;
    Comments.Caption := msg;

    WinSystem1.GetComputerInfo();
    msg := 'User: ' + WinSystem1.UserId;
    lblUsername.Caption := msg;
    msg := 'Computer: ' + WinSystem1.ComputerName;
    lblComputer.Caption := msg;
    WinSystem1.GetExeVersion(Application.ExeName);
    equalPos := Pos('=', WinSystem1.ProductName);
    ProductName.Caption := Copy(WinSystem1.ProductName, equalPos + 1, Length(WinSystem1.ProductName) - equalPos);
    equalPos := Pos('=', WinSystem1.FileVersion);
    Version.Caption := 'Release: ' + Copy(WinSystem1.FileVersion, equalPos + 1, Length(WinSystem1.FileVersion) - equalPos);
    equalPos := Pos('=', WinSystem1.LegalCopyright);
    Copyright.Caption := Copy(WinSystem1.LegalCopyright, equalPos + 1, Length(WinSystem1.LegalCopyright) - equalPos);

end;

procedure TAboutBox.lblURLMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
    lblURL.Font.Style :=     lblURL.Font.Style + [fsUnderline];
end;

procedure TAboutBox.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
    lblURL.Font.Style :=     lblURL.Font.Style - [fsUnderline];
end;

end.

